﻿#region Using directives

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Text;
using System.Windows.Forms;

#endregion

namespace PensSample {
  partial class AlignmentsForm : Form {
    public AlignmentsForm() {
      InitializeComponent();
    }

    private void AlignmentsForm_Paint(object sender, PaintEventArgs e) {
      Graphics g = e.Graphics;
      string[] alignNames = Enum.GetNames(typeof(PenAlignment));
      Array.Sort(alignNames);

      int x = 0;
      int y = 0;
      int width = this.ClientRectangle.Width;
      int height = this.ClientRectangle.Height / 2;
      Brush blackBrush = Brushes.Black;
      Pen redPen = System.Drawing.Pens.Red;

      foreach( string alignName in alignNames ) {
        using( Pen pen = new Pen(Color.White, 13) ) {
          pen.Alignment = (PenAlignment)Enum.Parse(typeof(PenAlignment), alignName);
          // Only two values supported
          if( pen.Alignment != PenAlignment.Center && pen.Alignment != PenAlignment.Inset ) continue;
          g.DrawEllipse(pen, x + 10, y + 10, width - 20, height - 20);
          g.DrawEllipse(redPen, x + 10, y + 10, width - 20, height - 20);
          StringFormat format = new StringFormat();
          format.Alignment = StringAlignment.Center;
          format.LineAlignment = StringAlignment.Center;
          g.DrawString(alignName, this.Font, blackBrush, new Rectangle(x, y, width, height), format);
          y += height;
        }
      }
    }
  }
}