using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters;
using System.Runtime.Serialization.Formatters.Binary;
using System.Text;

namespace AppliedDataBindingSample {

  public class State {
    private int id;
    private string name;
    public State(int id, string name) {
      this.id = id;
      this.name = name;
    }
    public int Id {
      get { return this.id; }
      set { this.id = value; }
    }
    public string Name {
      get { return this.name; }
      set { this.name = value; }
    }
  }
  
  public class States : BindingList<State>, IComponent {

    #region IComponent Members

    ISite site = null;

    [DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
    [Browsable(false)]
    public ISite Site {
      get { return site; }
      set { site = value; }
    }

    public event EventHandler Disposed;

    #endregion

    #region IDisposable
    bool disposed;

    public void Dispose() {
      Dispose(true);
      GC.SuppressFinalize(this);
    }

    protected virtual void Dispose(bool disposing) {
      if( !disposed ) {
        if( !this.disposed ) {
          this.disposed = true;
          if( this.Disposed != null ) this.Disposed(this, EventArgs.Empty);
        }
      }
    }

    ~States() {
      Dispose(false);
    }

    #endregion
  }
}
