using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;

namespace AppliedDataBindingSample {
  public class Race : INotifyPropertyChanged {

    #region INotifyPropertyChanged Members

    public event PropertyChangedEventHandler PropertyChanged;

    private void OnPropertyChanged(string propertyName) {
      if( this.PropertyChanged != null ) {
        this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
      }
    }

    #endregion
    
    string track;
    DateTime date;
    RaceCarDrivers drivers = new RaceCarDrivers();

    // Needed so DGV can add new rows
    public Race() { }
    public Race(string track, DateTime date, RaceCarDrivers drivers) {
      this.track = track;
      this.date = date;
      this.drivers = drivers;
    }

    public string Track {
      get { return this.track; }
      set {
        this.track = value;
        this.OnPropertyChanged("Track");
      }
    }

    public DateTime Date {
      get { return this.date; }
      set {
        this.date = value;
        this.OnPropertyChanged("Date");
      }
    }

    public RaceCarDrivers Drivers {
      get { return this.drivers; }
      set {
        this.drivers = value;
        this.OnPropertyChanged("Drivers");
      }
    }
  }
}
