using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace AppliedDataBindingSample {
  public partial class SupplierBrowserForm : Form {
    public SupplierBrowserForm() {
      InitializeComponent();

      ToolStrip ts = this.toolStrip;

      // Configure table structure
      ts.LayoutStyle = ToolStripLayoutStyle.Table;
      TableLayoutSettings tableLayout = ts.LayoutSettings as TableLayoutSettings;
      tableLayout.ColumnCount = 9;
      tableLayout.RowCount = 1;
      tableLayout.ColumnStyles.Add(new ColumnStyle());
      tableLayout.ColumnStyles.Add(new ColumnStyle());
      tableLayout.ColumnStyles.Add(new ColumnStyle());
      tableLayout.ColumnStyles.Add(new ColumnStyle());
      tableLayout.ColumnStyles.Add(new ColumnStyle());
      tableLayout.ColumnStyles.Add(new ColumnStyle());
      tableLayout.ColumnStyles.Add(new ColumnStyle());
      // Spring contents of this column, which will be the drop down list
      tableLayout.ColumnStyles.Add(new ColumnStyle(SizeType.Percent, 100F));
      tableLayout.ColumnStyles.Add(new ColumnStyle());
      // Make sure rowheight is 25 pixels, the default, since without
      // setting the height the table is only as high as the contained
      // controls
      tableLayout.RowStyles.Add(new RowStyle(SizeType.Absolute, 25F));

      // Fill up the entire cell
      foreach( ToolStripItem toolStripItem in ts.Items ) {
        toolStripItem.Dock = DockStyle.Fill;
      }
    }

    public SupplierBrowserForm(string url) : this() {
      this.webBrowser.Navigate(url);
    }

    private void backToolStripButton_Click(object sender, EventArgs e) {
      this.webBrowser.GoBack();
    }
    private void forwardToolStripButton_Click(object sender, EventArgs e) {
      this.webBrowser.GoForward();
    }
    private void stopToolStripButton_Click(object sender, EventArgs e) {
      this.webBrowser.Stop();
    }
    private void refreshToolStripButton_Click(object sender, EventArgs e) {
      this.webBrowser.Refresh();
    }
    private void homeToolStripButton_Click(object sender, EventArgs e) {
      this.webBrowser.GoHome();
    }
    private void goToolStripButton_Click(object sender, EventArgs e) {
      // Navigate to url
      this.webBrowser.Navigate(this.addressToolStripTextBox.Text);
    }
    private void webBrowser_Navigated(object sender, WebBrowserNavigatedEventArgs e) {
      // When finished navigating, make sure Address text matches
      // the url which we navigated to
      this.addressToolStripTextBox.Text = this.webBrowser.Url.ToString();
    }
  }
}