using System;
using System.Text;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;

[WebService(Namespace = "http://tempuri.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
public class CalcPiService : System.Web.Services.WebService {
  public CalcPiService() {

  }

  [WebMethod]
  public string CalcPi(int digits) {
    StringBuilder pi = new StringBuilder("3", digits + 2);

    if( digits > 0 ) {
      pi.Append(".");

      for( int i = 0; i < digits; i += 9 ) {
        int nineDigits = NineDigitsOfPi.StartingAt(i + 1);
        int digitCount = Math.Min(digits - i, 9);
        string ds = string.Format("{0:D9}", nineDigits);
        pi.Append(ds.Substring(0, digitCount));

        // End execution if client disconnects from web service
        if( !Context.Response.IsClientConnected )
          break;
      }
    }
    return pi.ToString();
  }
}
